=== lib/engine_graphics/thirdparty/ftgl/debian/control ===
Source: ftgl
Section: libs
Priority: optional
Maintainer: Sam Hocevar <sho@debian.org>
Build-Depends: debhelper (>= 5.0), quilt, libgl1-mesa-dev | libgl-dev, libglu1-mesa-dev | libglu-dev, libfreetype6-dev (>> 2.0.9), freeglut3-dev, libcppunit-dev, doxygen, imagemagick, texlive-latex-base, texlive-base-bin, texlive-font-utils, texlive-latex-recommended, texlive-fonts-recommended, ghostscript, cmake
Standards-Version: 3.8.3

Package: libftgl-dev
Section: libdevel
Architecture: any
Depends: libftgl2 (= ${binary:Version}), libfreetype6-dev (>> 2.0.9), libgl1-mesa-dev | libgl-dev, libglu1-mesa-dev | libglu-dev, ${shlibs:Depends}, ${misc:Depends}
Conflicts: ftgl-dev (<< 2.1.3~rc1)
Replaces: ftgl-dev (<< 2.1.3~rc1)
Description: development files for libftgl
 FTGL binds OpenGL and FreeType together in order to offer and easy to use
 and flexible text rendering library.  It offers several rendering modes:
 as polygons, outlines, bitmaps and textures.
 .
 This package contains the header files and static libraries needed to
 compile applications or shared objects that use libftgl.

Package: libftgl2
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: library to render text in OpenGL using FreeType
 FTGL binds OpenGL and FreeType together in order to offer and easy to use
 and flexible text rendering library.  It offers several rendering modes:
 as polygons, outlines, bitmaps and textures.
 .
 This package contains the shared library for libftgl.

Package: ftgl-dev
Section: oldlibs
Architecture: all
Depends: libftgl-dev, ${misc:Depends}
Description: transitional dummy package
 This is a transitional dummy package.  If nothing depends on it, this
 package can be safely removed.
