=== lib/engine_graphics/thirdparty/ftgl/debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper.
# GNU copyright 1997 to 1999 by Joey Hess.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

CFLAGS = -Wall -g

DTMPDIR = $(CURDIR)/debian/tmp

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
CFLAGS += -O0
else
CFLAGS += -O2
endif
ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
INSTALL_PROGRAM += -s
endif

configure: configure-stamp
configure-stamp:
	dh_testdir
	QUILT_PATCHES=debian/patches quilt push -a || test $$? = 2
#	./configure --prefix=/usr --mandir=\$${prefix}/share/man --infodir=\$${prefix}/share/info
	touch $@

build: build-stamp
build-stamp: configure-stamp
	dh_testdir
#	$(MAKE) CFLAGS="$(CFLAGS)"
	mkdir -p $(CURDIR)/build-debian
	(cd $(CURDIR)/build-debian; cmake -DCMAKE_VERBOSE_MAKEFILE:BOOL=1 -DCMAKE_INSTALL_PREFIX:PATH=/usr -DCMAKE_BUILD_TYPE:STRING=Release ..)

	(cd $(CURDIR)/build-debian; $(MAKE) )
	touch $@

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp configure-stamp
	rm -rf $(CURDIR)/build-debian
	[ ! -f Makefile ] || $(MAKE) distclean
	QUILT_PATCHES=debian/patches quilt pop -a -R || test $$? = 2
	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_clean -k
	(cd $(CURDIR)/build-debian; $(MAKE) install DESTDIR=$(DTMPDIR) )
#	mv debian/tmp/usr/share/doc/ftgl debian/tmp/usr/share/doc/libftgl-dev
	dh_install --list-missing --sourcedir=debian/tmp

binary-indep: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs -i ChangeLog
	dh_installdocs -i
	dh_installexamples -i
	dh_compress -i
	dh_fixperms -i
	dh_installdeb -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i

binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs -a ChangeLog
	dh_installdocs -a
	dh_installexamples -a
#	dh_installdebconf -a
#	dh_installmenu -a
#	dh_installinfo -a
	dh_installman -a
#	dh_undocumented -a
	dh_link -a
	dh_strip -a
	dh_compress -a
	dh_fixperms -a
	dh_makeshlibs -p libftgl2 -V 'libftgl2 (>= 2.1.3~rc5)'
	dh_installdeb -a
	dh_shlibdeps -a
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure
